# Az - Queue Storage Privesc

{{#include ../../../banners/hacktricks-training.md}}

## Queue

Za više informacija pogledajte:

{{#ref}}
../az-services/az-queue.md
{{#endref}}

### DataActions: `Microsoft.Storage/storageAccounts/queueServices/queues/messages/read`

Napadač sa ovom dozvolom može da pregleda poruke iz Azure Storage Queue. Ovo omogućava napadaču da vidi sadržaj poruka bez označavanja kao obrađenih ili menjanja njihovog stanja. To može dovesti do neovlašćenog pristupa osetljivim informacijama, omogućavajući eksfiltraciju podataka ili prikupljanje obaveštajnih podataka za dalja napada.
```bash
az storage message peek --queue-name <queue_name> --account-name <storage_account>
```
**Potencijalni uticaj**: Neovlašćen pristup redu, izlaganje poruka ili manipulacija redom od strane neovlašćenih korisnika ili servisa.

### DataActions: `Microsoft.Storage/storageAccounts/queueServices/queues/messages/process/action`

Sa ovom dozvolom, napadač može da preuzme i obradi poruke iz Azure Storage Queue. To znači da mogu da pročitaju sadržaj poruke i označe je kao obrađenu, efikasno je skrivajući od legitimnih sistema. To može dovesti do izlaganja osetljivih podataka, prekida u načinu na koji se poruke obrađuju, ili čak zaustavljanja važnih radnih tokova čineći poruke nedostupnim njihovim predviđenim korisnicima.
```bash
az storage message get --queue-name <queue_name> --account-name <storage_account>
```
### DataActions: `Microsoft.Storage/storageAccounts/queueServices/queues/messages/add/action`

Sa ovom dozvolom, napadač može dodati nove poruke u Azure Storage Queue. Ovo im omogućava da ubace zlonamerne ili neovlašćene podatke u red, potencijalno pokrećući nepredviđene akcije ili ometajući usluge koje obrađuju poruke.
```bash
az storage message put --queue-name <queue-name> --content "Injected malicious message" --account-name <storage-account>
```
### DataActions: `Microsoft.Storage/storageAccounts/queueServices/queues/messages/write`

Ova dozvola omogućava napadaču da doda nove poruke ili ažurira postojeće u Azure Storage Queue. Korišćenjem ove dozvole, mogli bi umetnuti štetan sadržaj ili izmeniti postojeće poruke, potencijalno obmanjujući aplikacije ili uzrokujući neželjeno ponašanje u sistemima koji se oslanjaju na red.
```bash
az storage message put --queue-name <queue-name> --content "Injected malicious message" --account-name <storage-account>

#Update the message
az storage message update --queue-name <queue-name> \
--id <message-id> \
--pop-receipt <pop-receipt> \
--content "Updated message content" \
--visibility-timeout <timeout-in-seconds> \
--account-name <storage-account>
```
### Action: `Microsoft.Storage/storageAccounts/queueServices/queues/write`

Ova dozvola omogućava napadaču da kreira ili menja redove i njihove osobine unutar skladišnog naloga. Može se koristiti za kreiranje neovlašćenih redova, modifikovanje metapodataka ili promenu lista kontrole pristupa (ACL) kako bi se omogućio ili ograničio pristup. Ova sposobnost može ometati radne tokove, ubrizgati zlonamerne podatke, eksfiltrirati osetljive informacije ili manipulisati podešavanjima reda kako bi se omogućili dalji napadi.
```bash
az storage queue create --name <new-queue-name> --account-name <storage-account>

az storage queue metadata update --name <queue-name> --metadata key1=value1 key2=value2 --account-name <storage-account>

az storage queue policy set --name <queue-name> --permissions rwd --expiry 2024-12-31T23:59:59Z --account-name <storage-account>
```
## Reference

- [https://learn.microsoft.com/en-us/azure/storage/queues/storage-powershell-how-to-use-queues](https://learn.microsoft.com/en-us/azure/storage/queues/storage-powershell-how-to-use-queues)
- [https://learn.microsoft.com/en-us/rest/api/storageservices/queue-service-rest-api](https://learn.microsoft.com/en-us/rest/api/storageservices/queue-service-rest-api)
- [https://learn.microsoft.com/en-us/azure/storage/queues/queues-auth-abac-attributes](https://learn.microsoft.com/en-us/azure/storage/queues/queues-auth-abac-attributes)

{{#include ../../../banners/hacktricks-training.md}}
